VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "System"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private Declare Function apiUserName Lib "advapi32.dll" Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function apiCompName Lib "kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function apiWindDir Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function apiSysDir Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function apiTempDir Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Sub apiMemStatus Lib "kernel32" Alias "GlobalMemoryStatus" (lpBuffer As MEMORYSTATUS)
Private Type MEMORYSTATUS
        dwLength As Long
        dwMemoryLoad As Long
        dwTotalPhys As Long
        dwAvailPhys As Long
        dwTotalPageFile As Long
        dwAvailPageFile As Long
        dwTotalVirtual As Long
        dwAvailVirtual As Long
End Type
Private Declare Sub apiSystemInfo Lib "kernel32" Alias "GetSystemInfo" (lpSystemInfo As SYSTEM_INFO)
Private Type SYSTEM_INFO
        dwOemID As Long
        dwPageSize As Long
        lpMinimumApplicationAddress As Long
        lpMaximumApplicationAddress As Long
        dwActiveProcessorMask As Long
        dwNumberOfProcessors As Long
        dwProcessorType As Long
        dwAllocationGranularity As Long
        dwReserved As Long
End Type
Private Declare Function apiDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
Private Declare Function apiDiskFreeSpace Lib "kernel32" Alias "GetDiskFreeSpaceA" (ByVal lpRootPathName As String, lpSectorsPerCluster As Long, lpBytesPerSector As Long, lpNumberOfFreeClusters As Long, lpTtoalNumberOfClusters As Long) As Long
Private Declare Function apiFastFreeSpace Lib "STKIT432.DLL" Alias "DISKSPACEFREE" () As Long
Private Declare Function apiGetDrives Lib "kernel32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function apiSerialNumber Lib "kernel32" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long
Private Declare Function apiMonitors Lib "winspool.drv" Alias "EnumMonitorsA" (ByVal pName As String, ByVal Level As Long, pMonitors As Byte, ByVal cbBuf As Long, pcbNeeded As Long, pcReturned As Long) As Long
Private Type MONITOR_INFO_1
        pName As String
End Type
Private Type MONITOR_INFO_2
        pName As String
        pEnvironment As String
        pDLLName As String
End Type
Private Declare Function apiGetVersion Lib "kernel32" Alias "GetVersionExA" (ByRef lpVersionInformation As OSVERSIONINFO) As Long
Private Type OSVERSIONINFO
       dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128
End Type

Private Declare Function apiKeyboardType Lib "user32" Alias "GetKeyboardType" (ByVal nTypeFlag As Long) As Long
Public Sub DriveInfo(ByVal strRoot As String, ByRef lngTotalSpace As Long, ByRef lngFreeSpace As Long)

Dim TotalClusters As Long
Dim FreeClusters As Long
Dim SectorsPerCluster As Long
Dim BytesPerSector As Long

If apiDiskFreeSpace(strRoot, SectorsPerCluster, BytesPerSector, FreeClusters, TotalClusters) Then

    lngTotalSpace = SectorsPerCluster * BytesPerSector * TotalClusters
    lngFreeSpace = SectorsPerCluster * BytesPerSector * FreeClusters
Else

    lngTotalSpace = 0
    lngFreeSpace = 0
End If

End Sub


Public Sub Drives(ByRef intRemovable As Integer, ByRef intNotRemovable As Integer, ByRef intCD As Integer, ByRef intRAM As Integer, ByRef intNetwork As Integer)

Dim Retrn As Long
Dim Buffer As Long
Dim Temp As String
Dim intI As Integer
Dim Read As String
Dim Counter As Integer
Buffer = 10

Again:
Temp = Space$(Buffer)
Retrn = apiGetDrives(Buffer, Temp)


If Retrn > Buffer Then
    Buffer = Retrn
    GoTo Again
End If

Counter = 0
For intI = 1 To (Buffer - 4) Step 4

    Counter = Counter + 1
    Read = Mid$(Temp, intI, 3)
    
    Select Case DriveType(Read)
        Case "Removable drive"
            intRemovable = intRemovable + 1
        Case "Fixed drive"
            intNotRemovable = intNotRemovable + 1
        Case "Network drive"
            intNetwork = intNetwork + 1
        Case "CD-ROM drive"
            intCD = intCD + 1
        Case "RAM-disk"
            intRAM = intRAM + 1
    End Select

Next

End Sub

Public Function DriveType(ByVal strRoot As String) As String

Dim lngType As Long
Const DRIVE_CDROM = 5
Const DRIVE_FIXED = 3
Const DRIVE_RAMDISK = 6
Const DRIVE_REMOTE = 4
Const DRIVE_REMOVABLE = 2

lngType = apiDriveType(strRoot)

Select Case lngType
    Case DRIVE_REMOVABLE
        DriveType = "Removable drive"
    Case DRIVE_FIXED
        DriveType = "Fixed drive"
    Case DRIVE_REMOTE
        DriveType = "Network drive"
    Case DRIVE_CDROM
        DriveType = "CD-ROM drive"
    Case DRIVE_RAMDISK
        DriveType = "RAM-disk"
    Case Else
        DriveType = ""
End Select

End Function


Public Function PutPoints(ByVal lngNumber As Long) As String

Dim NumOfPlaces As Integer
Dim Counter As Integer
Dim CurValue As String
Dim Remainder As Long

If Len(lngNumber) > 3 Then
    
    NumOfPlaces = Len(CStr(lngNumber)) \ 3
   
    If NumOfPlaces = Len(CStr(lngNumber)) / 3 Then
        NumOfPlaces = NumOfPlaces - 1
    End If
    For Counter = 0 To NumOfPlaces - 1
        PutPoints = "." + CStr(Mid$(lngNumber, Len(CStr(lngNumber)) - ((Counter * 3) + 2), 3)) + CurValue
        CurValue = PutPoints
    Next
    
    Remainder = Len(CStr(lngNumber)) - (((Counter - 1) * 3) + 2) - 1
    PutPoints = CStr(Left$(lngNumber, Remainder)) + CurValue

Else

    PutPoints = lngNumber

End If


End Function
Public Function FastDiskSpace(ByVal strRoot As String) As Long

Dim strCurrent As String
On Error GoTo Bliep

strCurrent = CurDir
ChDrive strRoot

FastDiskSpace = apiFastFreeSpace

ChDrive Left$(strCurrent, 2)
ChDir strCurrent

Exit Function

Bliep:

FastDiskSpace = 0
ChDrive Left$(strCurrent, 2)
ChDir strCurrent

End Function

Public Sub FreeMemory(ByRef btePercentUsed As Byte, ByRef lngTotalRam As Long, ByRef lngFreeRam As Long)

Dim Memory As MEMORYSTATUS

Memory.dwLength = 32


apiMemStatus Memory

btePercentUsed = Memory.dwMemoryLoad
lngTotalRam = Memory.dwTotalPhys / 1024
lngFreeRam = Memory.dwAvailPhys / 1024

End Sub
Public Function FunctionKeys() As Byte
FunctionKeys = apiKeyboardType(2)

End Function
Public Function KeyboardType() As String
Dim intBuffer As Long

intBuffer = apiKeyboardType(0)
Select Case intBuffer
Case 1
    KeyboardType = "IBM PC/XT or compatible (83 key)"
Case 2
    KeyboardType = "Olivetti ""ico"" (102 key)"
Case 3
    KeyboardType = "IBM PC/AT or compatible (84 key)"
Case 4
    KeyboardType = "IBM enhanced (101 or 102 key)"
Case 5
    KeyboardType = "Nokia 1050 or compatible"
Case 6
    KeyboardType = "Nokia 9140 or compatible"
Case 7
    KeyboardType = "Japanese"
End Select

End Function
Public Sub SystemInfo(ByRef strProcessor As String, ByRef lngNumOfProcessors As Long, ByRef lngActiveProcessor As Long)
Dim SI As SYSTEM_INFO

apiSystemInfo SI
        
lngActiveProcessor = SI.dwActiveProcessorMask
lngNumOfProcessors = SI.dwNumberOfProcessors

Select Case SI.dwProcessorType
Case 386
    strProcessor = "80386"
Case 486
    strProcessor = "80486"
Case 586
    strProcessor = "Intel Pentium"
End Select


End Sub
Public Function TempDir() As String
Dim Bufstr As String
Bufstr = Space$(50)
If apiTempDir(50, Bufstr) > 0 Then
    TempDir = Bufstr
    TempDir = RTrim(TempDir)
    TempDir = StripTerminator(TempDir)
    
    If Right$(TempDir, 1) <> "\" Then
        TempDir = TempDir + "\"
    End If
    
Else
    TempDir = ""
End If
        
End Function
Public Function SystemDir() As String

Dim Bufstr As String
Bufstr = Space$(50)

If apiSysDir(Bufstr, 50) > 0 Then
    SystemDir = Bufstr
    SystemDir = RTrim(SystemDir)
    SystemDir = StripTerminator(SystemDir)
    
    If Right$(SystemDir, 1) <> "\" Then
        SystemDir = SystemDir + "\"
    End If
    
Else
    SystemDir = ""
End If
        
End Function
Public Function ComputerName() As String
Dim Bufstr As String
Bufstr = Space$(50)
If apiCompName(Bufstr, 50) > 0 Then
    ComputerName = Bufstr
    ComputerName = RTrim(ComputerName)
    ComputerName = StripTerminator(ComputerName)
Else
    ComputerName = ""
End If
        
End Function
Private Function StripTerminator(ByVal strString As String) As String
    Dim intZeroPos As Integer

    intZeroPos = InStr(strString, Chr$(0))
    If intZeroPos > 0 Then
        StripTerminator = Left$(strString, intZeroPos - 1)
    Else
        StripTerminator = strString
    End If

End Function
Public Function UserName() As String

Dim Bufstr As String
Bufstr = Space$(50)

If apiUserName(Bufstr, 50) > 0 Then
    UserName = Bufstr
    UserName = RTrim(UserName)
    UserName = StripTerminator(UserName)
Else
    UserName = ""
End If
        
End Function
Public Function SerialNumber(ByVal strRoot As String) As String

Dim VolLabel As String
Dim VolSize As Long
Dim SerNum As Long
Dim MaxLen As Long
Dim Flags As Long
Dim Name As String
Dim NameSize As Long
Dim Check As String

If apiSerialNumber(strRoot, VolLabel, VolSize, SerNum, MaxLen, Flags, Name, NameSize) Then
    Check = Format(Hex(SerNum), "00000000")
    SerialNumber = Left$(Check, 4) + "-" + Right$(Check, 4)
Else
    SerialNumber = "0000-0000"
End If

End Function

Public Function VolumeLabel(ByVal strRoot As String) As String
On Error GoTo Further

VolumeLabel = Dir(strRoot, vbVolume)
VolumeLabel = StripTerminator(VolumeLabel)


If VolumeLabel = "" Then VolumeLabel = "NoName"


Exit Function


Further:
VolumeLabel = ""


End Function

Public Function WinDir() As String

Dim Bufstr As String
Bufstr = Space$(50)
If apiWindDir(Bufstr, 50) > 0 Then
    WinDir = Bufstr
    WinDir = RTrim(WinDir)
    WinDir = StripTerminator(WinDir)
    
    If Right$(WinDir, 1) <> "\" Then
        WinDir = WinDir + "\"
    End If
    
Else
    WinDir = ""
End If
        
End Function
Public Sub WinVer(ByRef intMajor As Integer, ByRef intMinor As Integer, ByRef strPlatform As String)
Dim OSystem As OSVERSIONINFO

OSystem.dwOSVersionInfoSize = 148

If apiGetVersion(OSystem) Then

    intMajor = OSystem.dwMajorVersion
    intMinor = OSystem.dwMinorVersion
    
    Select Case OSystem.dwPlatformId
    Case 0
        strPlatform = "Windows " + CStr(intMajor) + "." + CStr(intMinor)
    Case 1
        strPlatform = "Windows 95"
    Case 2
        strPlatform = "Windows NT"
    End Select

Else

    intMajor = 0
    intMinor = 0
    strPlatform = ""

End If

End Sub
